package cn.dejavu.AdvancedChatFilter;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import net.md_5.bungee.api.connection.Connection;
import net.md_5.bungee.api.connection.ProxiedPlayer;

import java.io.PrintWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.logging.Level;

public class censorWebhook {
    private ExecutorService executor = Executors.newFixedThreadPool(1);
    public censorWebhook (ProxiedPlayer sender, Connection receiver, String singleCensorWord){
        submit(sender.getUniqueId(),sender.getName(),System.currentTimeMillis(),receiver.getAddress().toString(),singleCensorWord);
    }

    private void submit(UUID uuid, String username, long timeStamp, String receiverIPAddress, String censorWord){
        executor.submit(new Runnable() {
            @Override
            public void run() {
                try{
                    URL url = new URL(Main.instance.configuration.getString("submit.url"));
                    URLConnection conn = url.openConnection();
                    conn.setRequestProperty("accept", "*/*");
                    conn.setRequestProperty("connection", "Keep-Alive");
                    conn.setRequestProperty("user-agent","AdvancedChatFilter");
                    conn.setDoOutput(true);
                    conn.setDoInput(true);
                    PrintWriter out = new PrintWriter(conn.getOutputStream());
                    Map<String,String> map = new HashMap<>();
                    SubmitData data =  new SubmitData(Main.instance.configuration.getString("submit.key"),uuid.toString(),username,String.valueOf(username),receiverIPAddress,censorWord);
                    Gson gson = new Gson();
                    gson.toJson(data);
                    out.print(data);
                    out.flush();
                    out.close();
                }catch (Exception ex){
                    Main.instance.getLogger().log(Level.WARNING,"Failed to submit censor data.");
                    ex.printStackTrace();
                }


            }
        });

    }
}
class SubmitData{
    String key;String uuid; String username; String time; String receiverip; String censorword;
    public SubmitData(String key,String uuid, String username, String time, String receiverip, String censorword){
        this.key=key;
        this.uuid=uuid;
        this.username=username;
        this.time=time;
        this.receiverip=receiverip;
        this.censorword=censorword;
    }
}